#include "stdafx.h"
#include <cstdio>
#include "Insert.h"

using namespace std;

unsigned int InsertTIMs(const char* TargetFile, const char* BuildFile, unsigned int& Inserted)
{
	Inserted = 0;
	FILE* target = fopen(TargetFile, "rb+");
	FILE* build = fopen(BuildFile, "r");
	FILE* insert;

	char fname[255];
	unsigned int InsertAddr;
	unsigned int FileSize;

	if(target == NULL)
	{
		fclose(build);
		return -1;
	}
	if(build == NULL)
	{
		fclose(target);
		return -2;
	}

	while(!feof(build))
	{
		if(3 == fscanf(build, "%s %u %u", fname, &InsertAddr, &FileSize))
		{
			insert = fopen(fname, "rb");
			if(insert == NULL)
				continue;

			fseek(target, InsertAddr, SEEK_SET);
			fseek(insert, 0, SEEK_END);
			unsigned int flen = ftell(insert);
			rewind(insert);

			if(flen != FileSize)
				printf("Warning: Filesize of %s does not match the original size in build file\n", fname);

			unsigned char* buf = new unsigned char[flen];
			unsigned int rlen = (unsigned int)fread(buf, 1, flen, insert);
			fclose(insert);
			insert = NULL;

			if(rlen != flen)
			{
				printf("Read error: file %s read %d of %d bytes\n", fname, rlen, flen);
				delete[] buf;
				buf = NULL;
				continue;
			}
			unsigned int wlen = (unsigned int)fwrite(buf, 1, flen, target);
			delete[] buf;
			buf = NULL;

			if(wlen != flen)
			{
				printf("Write error: file %s wrote %d of %d bytes\n", fname, wlen, flen);
				continue;
			}

			Inserted++;
			printf("Inserted %s: size %d offset $%X\n", fname, flen, InsertAddr);
		}
	}

	fclose(target);
	fclose(build);

	return 0;
}